-- Author      : danina /thrall
-- Create Date : 04/02/2011 12:14:13
-- 4.0.3a Dark Evangelism-update by akumu/soulflayer


Shadowtimer_Default_X = 0
Shadowtimer_Default_Y = 0
Shadowtimer_Default_Size = 100
Shadowtimer_Default_Scale = 1

MyAddon_UpdateInterval = 0.05; -- How often the OnUpdate code will run (in seconds)
WarningTime = 600; -- WarningTime (in milliseconds)
----------------------------------------------
local nameWeakenedSoul, rankWeakenedSoul = GetSpellInfo(6788);	--"Geschwchte Seele"  	-- just for testing purpose
local nameInnerFire, rankInnerFire = GetSpellInfo(588);	--"Inneres Feuer" 	-- just for testing purpose
local IconInnerFire = "Interface\\ICONS\\Spell_Holy_InnerFire.blp"
----------------------------------------------
local nameWordPain, rankWordPain = GetSpellInfo(589);	--"schmerz"
local IconWordPain = "Interface\\ICONS\\Spell_Shadow_ShadowWordPain.blp"
----------------------------------------------
--"Vampirberhrung"
local nameTouch, rankTouch, icon, cost, isFunnel, powerType, castTimeVT, minRange, maxRange = GetSpellInfo(34914)	
local IconTouch = "Interface\\ICONS\\Spell_Holy_Stoicism.blp"
----------------------------------------------
local namePlague, rankPlague = GetSpellInfo(2944);	--"Plague"
local IconPlague = "Interface\\ICONS\\Spell_Shadow_DevouringPlague.blp"
----------------------------------------------
local nameShadowOrbs, rankShadowOrbs = GetSpellInfo(77487);	--"Schattenkugeln"
local IconShadowOrbs = "Interface\\ICONS\\spell_priest_shadoworbs.blp"
----------------------------------------------
local nameEmpShadow, rankEmpShadow = GetSpellInfo(95799);	--"Empowered Shadow"
local IconEmpShadow = "Interface\\ICONS\\inv_chaos_orb.blp"
----------------------------------------------
local nameMindBlast, rankMindBlast = GetSpellInfo(8092);
----------------------------------------------
local nameDarkEvan, rankDarkEvan = GetSpellInfo(87118);	--"Dark Evangelism"
local IconDarkEvan = "Interface\\ICONS\\spell_holy_divineillumination.blp"
----------------------------------------------
local nameArchangel, rankArchangel = GetSpellInfo(87151);




function ShadowTimerFrame_OnLoad()
	ShadowTimerFrame:RegisterEvent("VARIABLES_LOADED");
	ShadowTimerFrame:RegisterEvent("PLAYER_LOGOUT");
	ShadowTimerFrame:RegisterEvent("ADDON_LOADED");

	DEFAULT_CHAT_FRAME:AddMessage("---Simple shadow timers loaded---");
	Texture1:SetTexture(IconTouch)
	Texture2:SetTexture(IconPlague)
	Texture3:SetTexture(IconWordPain)
	
	Texture6:SetTexture(IconShadowOrbs)
	Texture7:SetTexture(IconEmpShadow)
	Texture8:SetTexture(IconDarkEvan)
	
	Texture1:Hide()
	Texture2:Hide()
	Texture3:Hide()
	Texture6:Hide()
	Texture7:Hide()
	Texture8:Hide()

	TEXT5:SetText("")
	
	TimeSinceLastUpdate = 0

	ShadowTimerFrame:RegisterForDrag("LeftButton", "RightButton")
	ShadowTimerFrame:EnableMouse(false);
end

function ShadowTimerFrame_OnUpdate(elapsed)
		TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed; 	
		while (TimeSinceLastUpdate > MyAddon_UpdateInterval) do
			CheckCurrentTargetDeBuffs();
			CheckPlayerBuffs();
		TimeSinceLastUpdate = TimeSinceLastUpdate - MyAddon_UpdateInterval;
		end
end


function ShadowTimerFrame_OnEvent(self, event, ...)

		if (event == "ADDON_LOADED") then
			if ShadowtimerxPosiFrame then
				--DEFAULT_CHAT_FRAME:AddMessage(ShadowtimerxPosiFrame)
			end


 			if (ShadowtimerScaleFrame) then
				--DEFAULT_CHAT_FRAME:AddMessage("found stscale");
				ShadowTimerFrame:SetScale(ShadowtimerScaleFrame);
			else
				--DEFAULT_CHAT_FRAME:AddMessage("found no stscale");
				ShadowtimerScaleFrame = 1.0
			end



	
		end

		 if (event == "VARIABLES_LOADED" and addon == "ShadowTimers") then 
		  
			  if (not Shadowtimer_X) then
				Shadowtimer_X = Shadowtimer_Default_X
				Shadowtimer_Y = Shadowtimer_Default_Y
				Shadowtimer_Size = Shadowtimer_Default_Size
				
				DEFAULT_CHAT_FRAME:AddMessage("Shadowtimer Options not found. Generating...");
			  end
			

				--point, relativeTo, relativePoint, xOffset, yOffset = self:GetPoint(1);
				--ShadowtimerxPosiFrame = xOffset




		 elseif (event == "PLAYER_LOGOUT") then
---
		 end
end


function CheckCurrentTargetDeBuffs()
	local finished = false
	local count = 0
	local TouchFound = 0
	local TouchLeft = 0
	local PlagueFound = 0
	local PlagueLeft = 0
	local WordPainFound = 0
	local WordPainLeft = 0
	local Toutchlefttime = 0
	local CastTime = 0
	local TouchlasttickTime = 0
	local TouchlasttickcastTime = 0
	local ToutchleftMS = 0
	local PlaguelasttickTime = 0
	local PlaguelasttickCastTime = 0

	local name, rank, icon, cost, isFunnel, powerType, castTimeVT, minRange, maxRange = GetSpellInfo(34914)	 -- get castTime
	PseudoGCD = castTimeVT
	PseudoGCD2 = castTimeVT*2
	PseudoGCDWarn = castTimeVT+WarningTime
	TouchlasttickTime = castTimeVT*3+WarningTime -- unbuffed 1.5*2 time vonticks + 1.5 cast time
	TouchlasttickcastTime = castTimeVT*3 -- unbuffed 1.5*2 time vonticks + 1.5 cast time)
	PlaguelasttickTime = castTimeVT*2+WarningTime
	PlaguelasttickCastTime = castTimeVT*2  -- unbuffed und nichtgeskilled 3000 ms
--new
--info
--with enough haste u get an additional tick  these must be taken into account so
--normal touchtime=15 when ur globalcd == 1,5 you get 5 ticks @ 3,0 sec intervall
--normal Plaguetime=24 when ur GCD = 1,5 you get 8 ticks @ 3,0 sec intervall

-- the best time to renew the dot is 1ms after the last tick
--lets assume u have a Gcd of 1.36  --->ticktimes	2,72/5.44/8.16/10.88/13.6/16,32/19.04/21.76/24.48/27.2
--lets assume u have a Gcd of 1.33  --->ticktimes	2,66/5.32/7,98/10.64/13.3/15,96/18,62/21.28/23,94/26.6
--under 1.363 GCD u get 6ticks of VB but remember  your last tick  comes after 15sec
--
--best casttime VB is and will be ((GCD*2)+GCD) bevor ending the debuff,course refrehing faster will add more time to the next AURA
-- u gonna get more ticks

	while not finished do
		count = count+1
		local bn,brank,bicon,bcount,bType,bduration,bexpirationTime,bisMine,bisStealable,bshouldConsolidate,bspellId =  UnitDebuff("target", count, 0)
		
		if not bn then
			finished = true
		else
			--DEFAULT_CHAT_FRAME:AddMessage("testing debuff");
			if bisMine == "player" then
				--DEFAULT_CHAT_FRAME:AddMessage("ismine debuff");
				
				if bn == nameTouch then 
					TouchFound = 1 
					Toutchlefttime = floor((((bexpirationTime-GetTime())*10)+ 0.5))/10				--Time left
					TouchLeft = string.format("%1.1f",Toutchlefttime)							-- as formated string
					ToutchleftMS = Toutchlefttime*1000
					CastTime = castTimeVT	
					ToutchleftMSSafe = ToutchleftMS-WarningTime
					--DEFAULT_CHAT_FRAME:AddMessage("VT_UP");	
				end
				if bn == namePlague then 
					PlagueFound = 1
					Plaguelefttime = floor((((bexpirationTime-GetTime())*10)+ 0.5))/10				--Time left
					PlagueLeft = string.format("%1.1f",Plaguelefttime)	 
					PlagueleftMS = Plaguelefttime*1000
				end
				if bn == nameWordPain then 
					WordPainFound = 1
					WordPainlefttime = floor((((bexpirationTime-GetTime())*10)+ 0.5))/10
					WordPainLeft = string.format("%1.1f",floor((((bexpirationTime-GetTime())*10)+ 0.5))/10)  
				end
			end
		end
	end
	if TouchFound == 1 then
		Texture1:Show()
		if  ToutchleftMS < TouchlasttickTime then
			if ToutchleftMS < TouchlasttickcastTime then
				Texture1:SetVertexColor(0.1, 0.6, 0.1);
			else 
				Texture1:SetVertexColor(0.9, 0.2, 0.2);
			end
		else
			Texture1:SetVertexColor(1.0, 1.0, 1.0);
		end
		TEXT1:SetText(TouchLeft)
		TEXT1:Show()	
		
	else
		TEXT1:Hide()
		Texture1:Hide()
	end

	if PlagueFound == 1 then
		Texture2:Show()
		if  PlagueleftMS < PlaguelasttickTime then
			if PlagueleftMS < PlaguelasttickCastTime  then
				Texture2:SetVertexColor(0.1, 0.6, 0.1);
			else 
				Texture2:SetVertexColor(0.9, 0.2, 0.2);
			end
		else
			Texture2:SetVertexColor(1.0, 1.0, 1.0);
		end
		TEXT2:SetText(PlagueLeft)
		TEXT2:Show()	
	else
		Texture2:Hide()
		TEXT2:Hide()
	end
	if WordPainFound == 1 then
		Texture3:Show()
		TEXT3:SetText(WordPainLeft)
		TEXT3:Show()
	else
		Texture3:Hide()
		TEXT3:Hide()
	end

return 
end



function CheckPlayerBuffs()
	local finished = false
	local count = 0
	local ShadowOrbsFound = 0
	local ShadowOrbsStacks = 0
	local ShadowOrbsLeft = 0
	local EmpShadowFound = 0
	local EmpShadowLeft = 0
	local DarkEvanFound = 0
	local DarkEvanStacks = 0
	local DarkEvanLeft = 0
	local AAleft = 0
	local AAstart = 0
	local AAduration = 0
	local AAenabled = 0
			
	while not finished do
		count = count+1
		local bn,brank,bicon,bcount,bType,bduration,bexpirationTime,bisMine,bisStealable,bshouldConsolidate,bspellId =  UnitBuff("player", count, 0)
		
		if not bn then
			finished = true
		else
			if bn == nameShadowOrbs then
				ShadowOrbsFound	= 1
				ShadowOrbsStacks	= bcount
				ShadowOrbsLeft	= string.format("%1.1f",floor((((bexpirationTime-GetTime())*10)+ 0.5))/10) 
			end
			if bn == nameEmpShadow then
				EmpShadowFound	= 1
				EmpShadowLeft	= string.format("%1.1f",floor((((bexpirationTime-GetTime())*10)+ 0.5))/10) 
			end	
			if bn == nameDarkEvan then 
				DarkEvanFound	= 1
              		 	DarkEvanStacks	= bcount
				DarkEvanLeft	= string.format("%1.1f",floor((((bexpirationTime-GetTime())*10)+ 0.5))/10)  
			end
		end
	end
	
	if ShadowOrbsFound == 1 then
		Texture6:Show()
		TEXT6:SetText(ShadowOrbsStacks)
		MBstart, MBduration, MBenabled = GetSpellCooldown(nameMindBlast);	--MB CD
			if ShadowOrbsStacks == 3 then
				if  MBduration <= PseudoGCD then
					Texture6:SetVertexColor(0.1, 0.6, 0.1);		--green
				elseif MBduration <= PseudoGCDWarn then
					Texture6:SetVertexColor(0.9, 0.2, 0.2);		--red
				end
			else								-- not 3 orbs
					Texture6:SetVertexColor(1.0, 1.0, 1.0);		--no colour
			end
		TEXT6:Show()	
	else
		Texture6:Hide()
		TEXT6:Hide()
	end
	

-- uncomment lines down for MB
--	MBstart, MBduration, MBenabled = GetSpellCooldown(nameMindBlast);
--	if  MBstart == 0 and MBduration <= PseudoGCD and MBenabled == 1 then   -- ;MBstart >= 0 and 
--	TEXT5:SetText("MB RDY")
--		TEXT5:SetSize(32, 32)
--		TEXT5:Show()
--	else
--		TEXT5:SetText(MBduration)
		TEXT5:Hide()
--	end





	if EmpShadowFound == 1 then
		Texture7:Show()
		TEXT7:SetText(EmpShadowLeft)	
		TEXT7:Show()	
	else
		Texture7:Hide()
		TEXT7:Hide()
	end

	if DarkEvanFound == 1 then
		Texture8:Show()
		TEXT8:SetText(DarkEvanLeft)
       		if DarkEvanStacks == 5 then
			AAstart, AAduration, AAenabled = GetSpellCooldown(nameArchangel);
			if not(AAstart == 0) and  not(AAduration == 0)then
				AAleft=(AAduration-(GetTime()-AAstart))*1000
					if  AAleft <= PseudoGCD then
						Texture8:SetVertexColor(0.1, 0.6, 0.1);
					elseif AAleft <= PseudoGCDWarn then
						Texture8:SetVertexColor(0.9, 0.2, 0.2);
					else
						Texture8:SetVertexColor(1.0, 1.0, 1.0);
					end
        		else
				Texture8:SetVertexColor(1.0, 1.0, 1.0);
			end
		end
		TEXT8:Show()
	else
		Texture8:Hide()
		TEXT8:Hide()
	end

return 
end


SLASH_SHADOWTIMERS1, SLASH_SHADOWTIMERS2 = '/st', '/ShadowTimers';
local function SLASH_SHADOWTIMERShandler(msg, editbox)
if msg == 'show' then
	ShadowTimerFrame:Show()
elseif  msg == 'hide' then
	ShadowTimerFrame:Hide()
elseif  msg == 'reset' then
	ShadowTimerFrame:Hide()
	ShadowTimerFrame:Show()	
elseif  msg == 'noconfigmode' then	
	ShadowTimerFrame:EnableMouse(false);
	ShadowTimerFrame:SetBackdrop(nil);
	STmode = 1
elseif  msg == 'configmode' then
	ShadowTimerFrame:EnableMouse(true);
	ShadowTimerFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile= "Interface/Tooltips/UI-Tooltip-Border", edgeSize = 4, tile = false, tileSize =16, insets = { left = 0, right = 0, top = 0, bottom = 0 }});
	STmode = 2
elseif  msg == 'scale1' then
ShadowtimerScaleFrame = 0.5
ShadowTimerFrame:SetScale(ShadowtimerScaleFrame);
elseif  msg == 'scale2' then
ShadowtimerScaleFrame = 0.6
ShadowTimerFrame:SetScale(ShadowtimerScaleFrame);
elseif  msg == 'scale3' then
ShadowtimerScaleFrame = 0.7
ShadowTimerFrame:SetScale(ShadowtimerScaleFrame);
elseif  msg == 'scale4' then
ShadowtimerScaleFrame = 0.8
ShadowTimerFrame:SetScale(ShadowtimerScaleFrame);
elseif  msg == 'scale5' then
ShadowtimerScaleFrame = 0.9
ShadowTimerFrame:SetScale(ShadowtimerScaleFrame);
elseif  msg == 'scale6' then
ShadowtimerScaleFrame = 1.0
ShadowTimerFrame:SetScale(ShadowtimerScaleFrame);

 else
   print("Syntax: /st (show | hide | reset | configmode | noconfigmode)");
   print("Syntax: /st (scale1 | scale2 | scale3 | scale4 | scale5 | scale6)");

 end
end
SlashCmdList["SHADOWTIMERS"] = SLASH_SHADOWTIMERShandler;







